
DOSUBST_INIT_MK =

noinst_SCRIPTS		+= dosubst

EXTRA_DIST		+= dosubst.in

CLEANFILES		+= dosubst

MAINTAINERCLEANFILES	+= dosubst.in

dosubst : dosubst.in
	./config.status --file=$@
	chmod +x $@

dosubst.in : configure.ac
	autoconf -t 'AC_SUBST:$$1'														\
	| perl -l																		\
		-e 'chomp(@L=<STDIN>);'														\
		-e 'print join qq<\n>, '													\
		-e 'q<#!/usr/bin/env perl>,'												\
		-e 'q<sub veval {>,'														\
		-e 'q<   my $$s = shift; $$s =~ s/@/\\\\@/g;>,'								\
		-e 'q<   $$s =~ s/\\$$\\$$/\\\\\\$$/g;>,'									\
		-e 'q<   $$s =~ s/"/\\\\"/g;>,'												\
		-e 'q<   my ($$ret, $$nret ) = ($$s);>,'									\
		-e 'q<     $$ret = $$nret while $$ret ne ($$nret = eval qq[qq[$$ret]]);>,'	\
		-e 'q<   return $$ret>,'													\
		-e 'q<}>,'																	\
		-e '(map { qq<\$$$$_ = q[\@$$_\@];> } @L),'									\
		-e '(map { qq<\$$$${_}_EVAL = veval q[\@$$_\@];> } @L),'					\
		-e 'qq<while(<>) {>,'														\
		-e '(map { qq<    s/[@]$${_}[@]/\$\$$$${_}/go;> } @L),'						\
		-e '(map { qq<    s/[@]$${_}_EVAL[@]/\$\$$$${_}_EVAL/go;> } @L),'			\
		-e 'qq<    print;>,'														\
		-e 'qq<}>;'																	\
	> $@
